/*API поменять на актуальный рут*/
const api_url = "https://api.mypost.kz/map_api";

var postpoints = null;
var constants = null;
var request = {
    idcity: 0,
    idtype: 0,
    allday: false,
    worktime: ""
};
$.ajax({
    method: 'POST',
    url: api_url+'/constants',
    async: false,
    crossDomain: true,
    success: function (data) {
        constants = data;
    }
});
$.ajax({
    method: 'POST',
    url: api_url,
    data: JSON.stringify({
       idcity:1
    }),
    crossDomain: true,
    async: false,
    success: function (data) {
        postpoints = data;
    }
});

let select_town = $('#select-town');
for(var city_id in constants.cities){
    var city = constants.cities[city_id];
    select_town.append($('<option>', {
        value: city_id,
        text : city.Name,
        lon  : city.Longitude,
        lat  : city.Latitude
    }));
}

let select_type = $('#select-type');
for(var type_id in constants.postpoint_types){
    var name = constants.postpoint_types[type_id];
    select_type.append($('<option>', {
        value: type_id,
        text : name
    }));
}

updatePostpointsList(postpoints.postpoints)

var map;
var myCollection;
var objectManager;

ymaps.ready(function () {
    map = new ymaps.Map('YMapsID', {
        center: [43.239793, 76.899020],
        zoom: 12,
        type: 'yandex#map',
        behaviors: ['default', 'scrollZoom']
    });

    myCollection = new ymaps.GeoObjectCollection();

    objectManager = new ymaps.ObjectManager({
        clusterize: true,
        geoObjectBalloonMinWidth: 150,
        maxWidth: 350,
        geoObjectBalloonMaxHeight: 230,
    });

    //пареметры обьектов на карте
    objectManager.objects.options.set({
        preset: 'islands#pinkIcon'
    });

    //Параметры кластера
    objectManager.clusters.options.set({
        preset: 'islands#pinkClusterIcons',
    });
    map.geoObjects.add(objectManager);

    objectManager.add(postpoints);

    /* TO-DO добавить привязку айди точки к полю postpoint_id
    balloonopen ивент перекрывает дефолтное открытие балуна по клику
    map.events.add('balloonopen', function (e) {
        if (map.balloon.isOpen()) {
            let postpoint_id = map.balloon.getData().object.id;
            $('#postpoint_input').val(postpoint_id);
            map.balloon.close();
        }
    });*/
});

//select town
function selectTown(){
    let select_town = $('#select-town').find('option:selected');
    let lon = select_town.attr('lon');
    let lat = select_town.attr('lat');
    if (select_town.attr('value') !== "0"){
        map.setCenter([lat, lon], 12);
    }else{
        map.setCenter([43.239793, 76.899020], 12);
    }

    request.idcity = parseInt(select_town.attr('value'));

    this.getData(request);

    return false;
}

//select type
function selectType() {
    let select_type = $('#select-type').find('option:selected');
    request.idtype = parseInt(select_type.attr('value'));

    this.getData(request);

    return false;
}

//select all day working postpoints
function selectAllDay() {
    request.allday = $('#select-allday').is(":checked");
    $('#worktime-select-div').css("filter", "blur(0)");
    if(request.allday == true){
        $('#worktime-select-div').children().prop('disabled',true);
        $('#worktime-select-div').css("filter", "blur(1px)");
    }else{
        $('#worktime-select-div').children().prop('disabled',false);
    }
    postpoints = this.getData(request);

    return false;
}

//select worktime
function selectWorkTime() {
    $('#empty-worktime-warning').text('');
    let time =  $('#select-time').find('option:selected').attr('value');
    let day = $('#select-weekday').find('option:selected').attr('value');
    if(time != "" && day != "") {
        request.worktime = time + "," + day;
        this.getData(request);
    }
    else if(time == "" && day == ""){
        request.worktime = "";
        this.getData(request);
    }
    else{
        $('#empty-worktime-warning').text('Выберите время и день!');
    }

    return false;
}

//update list
function updatePostpointsList(postpoints) {
    var postpoints_list = $('#postpoints_list');
    postpoints_list.html('');
    for(var pp_id in postpoints){
        var pp = postpoints[pp_id];
        var div = $("<div class='postpoint-card'><b><div><span>"+pp.Name+"</span></div></b>" +
            "<small><div><span>"+"<i class='fa fa-map-marker' style='color:red'></i> "+pp.Address+"</span></div><div><i class='fal fa-warehouse-alt'></i>"+pp.postpointType+" #"+pp_id+"</div>" +
            "<div><span><i class='fa fa-clock-o' style='color:green'></i> "+pp.WorkTime+"</span></div></small></div><hr>");
        postpoints_list.append(div);
        /*var button =  $("#button_"+pp_id);
        button.click(function(){
            setDivisionId(this.id);
        });*/
    }
}

//update map
function updateMap(postpoints) {
    objectManager.removeAll();
    objectManager.add(postpoints);
}

function getData(request) {
    var postpoints = null;
    $('#postpoints_list').html('');

    $.ajax({
        method: 'POST',
        url: api_url,
        data: JSON.stringify(request),
        crossDomain: true,
        async: true,
        success: function (data) {
            if (data != null && data.postpoints) {
                updatePostpointsList(data.postpoints);
                updateMap(data);
            }else{
                alert("Приносим извинения, карта временно не работает.");
            }
        }
    });

    return postpoints;
}

//set division id to input
function setDivisionId(button_id) {
    var id = button_id.substr(button_id.indexOf('_')+1);
    $('#postpoint_input').val(id);
}